'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.loader = exports.findMany = exports.find = undefined;

var _fp = require('lodash/fp');

var _utils = require('./utils');

var find = exports.find = (0, _fp.curry)(function (queryId, queries) {
  return (0, _fp.filter)({ queryId: queryId }, queries);
});

var findMany = exports.findMany = (0, _fp.curry)(function (queryIds, queries) {
  return (0, _fp.flow)([(0, _fp.map)(function (id) {
    return find(id, queries);
  }), _fp.flatten])(queryIds);
});

var loader = exports.loader = (0, _fp.curry)(function (queryIds, queries) {
  return (0, _utils.flowP)([(0, _utils.mapP)(_utils.call), (0, _fp.flow)([_fp.flatten, findMany(queryIds), (0, _fp.uniqBy)('queryId')])])((0, _fp.flow)([_fp.values, (0, _fp.map)('load')])(queries));
});

exports.default = {
  find: find,
  findMany: findMany,
  loader: loader
};